#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Gold

extern string TimeFrame = "current time frame";
extern int    maPeriod1 = 14;
extern int    maPeriod2 =  5;

double ma1[];
double ma2[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//
//
//
//
//

int init()
{
   SetIndexBuffer(0,ma1);
   SetIndexBuffer(1,ma2);
      timeFrame         = stringToTimeFrame(TimeFrame); // check the time frame
      indicatorFileName = WindowExpertName();           // save the indicator name for iCustom call
      returnBars        = TimeFrame == "returnBars";    // check if number of changed bars is asked for
   return(0); 
}
int deinit() { return(0); }

//
//
//
//
//

int start() 
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
         //
         //
         //    if the number of changed bars in the target time frame is required
         //    then store that number in the first buffer and in current bar value
         //    that way it can be retrieved buy the indicator using iCistom() call
         //
         //
         
         if (returnBars) { ma1[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period())); // check How many bars in the target time frame have changed
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  ma1[i] = iCustom(NULL,timeFrame,indicatorFileName,"",maPeriod1,maPeriod2,0,y);  // call the indicator itself in the target time frame
                  ma2[i] = iCustom(NULL,timeFrame,indicatorFileName,"",maPeriod1,maPeriod2,1,y);  // to get the results of regular calculation
            }
            return(0); // finish the multi time frame processing
         }
         
   //
   //
   // regular calculation - indicator will go here if timeFrame==Period() - when called from iCustom() call
   //
   //         
   
   for (i=limit; i>=0; i--) ma1[i] = iMA(NULL,0,maPeriod1,0,MODE_SMA,PRICE_CLOSE,i);
   for (i=limit; i>=0; i--) ma2[i] = iMAOnArray(ma1,0,maPeriod2,0,MODE_SMA,i);
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}